View Issue Details

IDProjectCategoryView StatusLast Update
0006508TalerMerchant frontends (Python3)public2020-08-23 12:19
ReporterChristian Grothoff Assigned ToChristian Grothoff  
PrioritynormalSeverityblockReproducibilityalways
Status resolvedResolutionfixed 
Platformi7OSDebian GNU/LinuxOS Versionsqueeze
Product Versiongit (master) 
Target Version0.8Fixed in Version0.8 
Summary0006508: launching taler-merchant-demos fails with strange error
DescriptionAfter configuring the port, I get:

$ taler-merchant-demos --serve-http blog
WARNING:taler.util.talerconfig:no base directory found
*** Starting uWSGI 2.0.19.1 (64bit) on [Sat Aug 22 21:54:49 2020] ***
compiled with version: 8.4.0 on 04 July 2020 21:45:29
os: Linux-4.19.0-10-amd64 #1 SMP Debian 4.19.132-1 (2020-07-24)
nodename: lifeline
machine: x86_64
clock source: unix
pcre jit disabled
detected number of CPU cores: 32
current working directory: /home/grothoff/research/taler/taler-merchant-demos
detected binary path: /home/grothoff/.local/bin/uwsgi
your processes number limit is 256903
your memory page size is 4096 bytes
detected max file descriptor number: 1024
lock engine: pthread robust mutexes
thunder lock: disabled (you can enable it with --thunder-lock)
uWSGI http bound on :8080 fd 4
uwsgi socket 0 bound to TCP address 127.0.0.1:35301 (port auto-assigned) fd 3
Python version: 3.8.5 (default, Aug 2 2020, 15:09:07) [GCC 10.2.0]
*** Python threads support is disabled. You can enable it with --enable-threads ***
Python main interpreter initialized at 0x55ecd80e8f40
your server socket listen backlog is limited to 100 connections
your mercy for graceful operations on workers is 60 seconds
mapped 145840 bytes (142 KB) for 1 cores
*** Operational MODE: single process ***
WARNING:taler.util.talerconfig:no base directory found
Traceback (most recent call last):
  File "./talermerchantdemos/blog/__init__.py", line 1, in <module>
    from talermerchantdemos.blog.blog import app
  File "./talermerchantdemos/blog/blog.py", line 40, in <module>
    BACKEND_BASE_URL = TC["frontends"]["backend"].value_string(required=True)
  File "/home/grothoff/.local/lib/python3.8/site-packages/taler/util/talerconfig.py", line 173, in value_string
    raise ConfigurationError(
taler.util.talerconfig.ConfigurationError: Missing required option 'BACKEND' in section 'FRONTENDS'
unable to load app 0 (mountpoint='') (callable not found or import error)
*** no app loaded. going in full dynamic mode ***
*** uWSGI is running in multiple interpreter mode ***
spawned uWSGI master process (pid: 43434)
spawned uWSGI worker 1 (pid: 43437, cores: 1)
spawned uWSGI http 1 (pid: 43438)

Several things wrong here:
1) there is no documentation, not even on how to build (configure, make install)
2) there is no documentation on the options to set
3) if the configuration is required (there should be sane defaults), and the configuration is wrong, then the process should print a GOOD error message
4) if the configuration is badly messed up, the process should EXIT and not continue to run as it does now
TagsNo tags attached.

Activities

Christian Grothoff

2020-08-22 22:05

manager   ~0016704

I now learned the solution is:

$ taler-config -s frontends -o backend -V https://backend.tet.taler.net/
$ taler-config -s frontends -o backend_apikey -V "ApiKey Sandbox"

Anyway, the error messages are horrible, the non-exiting is horrible, and the documentation is horrible.

Christian Grothoff

2020-08-23 12:19

manager   ~0016712

Torsten already added good instructions here on how to install.

Issue History

Date Modified Username Field Change
2020-08-22 22:04 Christian Grothoff New Issue
2020-08-22 22:05 Christian Grothoff Note Added: 0016704
2020-08-23 12:19 Christian Grothoff Assigned To => Christian Grothoff
2020-08-23 12:19 Christian Grothoff Status new => resolved
2020-08-23 12:19 Christian Grothoff Resolution open => fixed
2020-08-23 12:19 Christian Grothoff Fixed in Version => 0.8
2020-08-23 12:19 Christian Grothoff Note Added: 0016712